<?php

namespace src\models;

use src\debug\Debug;
use src\file_db_driver\FileDatabaseDriver;

#[\AllowDynamicProperties]
class BaseModel
{
    protected FileDatabaseDriver $fdd;

//    public int $id;

    public function __construct()
    {
        $this->fdd = new FileDatabaseDriver();
        $this->fdd->connect($this->file());
    }

    /**
     * @return array
     */
    public function fillable(): array
    {
        return [];
    }

    public function load(array $array): void
    {
        if (is_array($array)) {
            foreach ($array as $key => $value) {
                $this->{$key} = $value;
            }
        }
    }

    /**
     * @return string
     */
    public function file(): string
    {
        return "";
    }

    public function labels(): array
    {
        return [];
    }

    public function save(): void
    {
        $this->fdd->save($this->toString());
    }

    public function find(array $request = []): FileDatabaseDriver
    {
        return $this->fdd->find($request);
    }

    public function toString(): string
    {
        $str = '';
        $lastItems = array_key_last($this->fdd->getHeadKeys());
        foreach ($this->fdd->getHeadKeys() as $key => $value) {
            if (isset($this->{$value})) {
                if ($key === $lastItems) {
                    $str .= $this->{$value};
                } else {
                    $str .= $this->{$value} . ";";
                }
            }
        }

        return $str;
    }

    
}